(function($, Drupal, once) {

  Drupal.behaviors.image_compare_slider = {
    attach: function(context, settings) {
      once('image_compare', 'image-compare', context).forEach(function (element) {
        var range_input = element.shadowRoot.querySelector('input');
        if (range_input) {
          range_input.id = element.id + '_input';
          range_input.parentElement.setAttribute('for', range_input.id);
          if (parseInt(element.getAttribute('start')) > 0) {
            range_input.value = element.getAttribute('start');
          }
          range_input.dispatchEvent(new Event('change'));
          var mouseStep = 1;
          if (parseFloat(element.getAttribute('step')) < 1) {
            mouseStep = element.getAttribute('step');
            range_input.step = mouseStep;
          }
          var keyboardStep = 1;
          if (parseInt(element.getAttribute('keyboard_step')) > 1) {
            keyboardStep = parseInt(element.getAttribute('keyboard_step'));
          }
          if (mouseStep !== 1 || keyboardStep > 1) {
            range_input.addEventListener('keydown', function(evt) {
              // Only set the step on arrow key events.
              switch (evt.key) {
                case 'ArrowDown':
                case 'ArrowLeft':
                case 'ArrowRight':
                case 'ArrowUp':
                  range_input.step = keyboardStep;
              }
            });
            range_input.addEventListener('keyup', function() {
              range_input.step = mouseStep;
            });
          }
        }
      });
    }
  }

})(jQuery, Drupal, once);
